--Procedure To Send Message
CREATE PROCEDURE [dbo].[SendDelete]
	@FileName varchar(1024)
AS
DECLARE @DialogHandle uniqueidentifier,
		@msg XML,
		@date nvarchar(100)
BEGIN
	IF @msg IS NOT NULL
	BEGIN

		SET @DialogHandle = cast(dbo.GetSystemSettingValue('SSB_Session_Delete') as uniqueidentifier)

		IF CAST(RAND()*100 AS INT) = 0 OR @DialogHandle IS NULL
		BEGIN
		IF @DialogHandle IS NOT NULL
			SEND ON CONVERSATION @DialogHandle
			MESSAGE TYPE [MT_ConversationSwitch]


		BEGIN DIALOG CONVERSATION @dialogHandle
		FROM SERVICE [Svc_ObjectDelete_Source]
		TO SERVICE Svc_ObjectDelete_Destination
		ON CONTRACT [CT_ObjectDelete_Multi];

		UPDATE Setting
			SET DefaultValue = @DialogHandle
		WHERE SettingName = SSB_Session_Delete;
		END;
		SEND ON CONVERSATION @dialogHandle
		MESSAGE TYPE [MT_ObjectDelete]
		(@msg)


		IF @DialogHandle <> cast(dbo.GetSystemSettingValue('SSB_Session_Delete') as uniqueidentifier)
			SEND ON CONVERSATION @DialogHandle
			MESSAGE TYPE [MT_ConversationSwitch]
	END
END
GO


--Procedure To Receive Data
CREATE PROCEDURE [dbo].[util_ProcessDelMonitorData]
	@MsgToRead INT = 1000
AS

DECLARE @message_type_name sysname;
DECLARE @message_body VARBINARY(max)

DECLARE @msgTable TABLE
(
	message_body VARBINARY(max),
	[conversation_handle] UNIQUEIDENTIFIER
);
BEGIN
	DECLARE @conversation_handle UNIQUEIDENTIFIER

	WHILE 1=1
	BEGIN
		WAITFOR (RECEIVE TOP (1) @Message_Body = message_body,
			@conversation_handle = [conversation_handle],
			@message_type_name = message_type_name
		FROM [Q_ObjectDelete_Destination]), TIMEOUT 1000

		IF @conversation_handle IS NULL
		BEGIN
			break
		END

		IF @message_type_name = MT_ConversationSwitch
			END CONVERSATION @conversation_handle

		IF @message_body IS NOT NULL
		BEGIN
			INSERT INTO @msgTable
			(message_body, [conversation_handle])
			values
			(@message_body, @conversation_handle)
		END

		SET @conversation_handle = NULL
		SET @message_type_name = NULL
	END

	/*Business Logic happens here*/
END
GO